define(function( require ){

	const jQuery = require( 'jquery' );

	return function( s ){


		/*
			N O D E S
		 */
		let form_node  = jQuery( s.target_selector );
		let plz_node   = jQuery( '#zipcode' );
		let range_node = jQuery( '#distanceRange' );


		/*
			P R I V A T E   V A R S
		 */



		/*
			I N I T
		 */

		init( s );

		/*
			E V E N T S
		 */
		form_node.on( 'change', function( e ){
			set_filter();
		})

		range_node.on( 'change', function( e ){
			get_zipcode_value();
		})

		/*
			M E T H O D S
		 */
		 function init( s ){
			window.event_distance = false;
 		}

 		function update(){

 		}



		function set_filter(){
			let filter_json = get_input_values();
			let json_string = JSON.stringify( filter_json );
			let url_string  = encodeURI( json_string );
			//get_zipcode_value();
			location.hash = url_string;
		}

		function get_input_values(){
			const inputs = jQuery( s.target_selector + ' input[type="checkbox"]:checked' );
			const filter = {};
			inputs.each(function( node ){
				filter[this.name] = ( Array.isArray( filter[this.name] ) ) ? filter[this.name] : []; // Es wird erzwungen, dass der Filter ein array ist
				filter[this.name].push( this.value );
			})
			return filter
		}

		function get_zipcode_value(){

			zipcode  = parseInt( plz_node.val() );
			zipcode  = ( zipcode ) ? zipcode : '00000';
			plz_node.val( zipcode );
			distance = range_node.val();

			jQuery( '#event-posts' ).css( { opacity: '0.2' } );
			jQuery( '#event-posts' ).css( { transition: 'opacity 1s' } );

			if( distance < 240 ){
				const jqxhr = jQuery.ajax( '/wp-json/techdata/v1/zipcodes/'+zipcode+'/'+distance )
				.done(function( response ) {
					console.log( "success" );
					console.log( response );
					jQuery( '#event-posts' ).css( { opacity: '1' } );
					jQuery( '.tdIntro' ).html( '<h1>Events in der Nähe von: ' + response.name + '</h1>' );
					if( response.near_zipcode ){
						window.event_distance = response.near_zipcode;
						window.dispatchEvent( new CustomEvent( 'hashchange' ) );
					} else {
						window.event_distance = false;
					}
				})
				.fail(function( data ) {
					console.warn( "PLZ ERROR" );
					console.log( data );
					jQuery( '#event-posts' ).css( { opacity: '0.2' } );
					window.event_distance = false;
				})
				.always(function() {
					//
				});
			} else {
				jQuery( '.tdIntro' ).html( '<h1>Events</h1>' );
				window.event_distance = false;
				window.dispatchEvent( new CustomEvent( 'hashchange' ) );
				jQuery( '#event-posts' ).css( { opacity: '1' } );
			}
		}

		return{
			init : init,
		}
	}
})
